Bug 1292209 - Review Request: python-nsdf - Support library for the Neuroscience Simulation Data Format
Review Request: python-nsdf - Support library for the Neuroscience Simulation...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: William Moreno
Fedora Extras Quality Assurance
:
Depends On:
Blocks: fedora-neuro
  Show dependency treegraph
 
Reported: 2015-12-16 13:10 EST by Zbigniew Jędrzejewski-Szmek
Modified: 2016-01-17 13:50 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-01-17 12:51:19 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
williamjmorenor: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Zbigniew Jędrzejewski-Szmek 2015-12-16 13:10:33 EST
Spec URL: https://in.waw.pl/~zbyszek/fedora/python-nsdf.spec
SRPM URL: https://in.waw.pl/~zbyszek/fedora/python-nsdf-0.0-1.git2153112.fc24.src.rpm
Description: 

NSDF (Neuroscience Simulation Data Format) is a file format built on
top of HDF5 to store the results of computer simulation experiments.
%{name} provides a python module to read and write files in the NSDF
format.

Fedora Account System Username: zbyszek
Comment 1 Upstream Release Monitoring 2015-12-16 13:14:28 EST
zbyszek's scratch build of python-nsdf-0.0-1.git2153112.fc24.src.rpm for f23 failed http://koji.fedoraproject.org/koji/taskinfo?taskID=12217713
Comment 2 Upstream Release Monitoring 2015-12-16 13:14:30 EST
zbyszek's scratch build of python-nsdf-0.0-1.git2153112.fc24.src.rpm for rawhide failed http://koji.fedoraproject.org/koji/taskinfo?taskID=12217708
Comment 3 Upstream Release Monitoring 2015-12-16 13:23:33 EST
zbyszek's scratch build of python-nsdf-0.0-1.git2153112.fc24.src.rpm for f23 failed http://koji.fedoraproject.org/koji/taskinfo?taskID=12217809
Comment 4 Upstream Release Monitoring 2015-12-16 13:23:57 EST
zbyszek's scratch build of python-nsdf-0.0-1.git2153112.fc24.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=12217807
Comment 5 Zbigniew Jędrzejewski-Szmek 2015-12-16 13:52:13 EST
F23 build: http://koji.fedoraproject.org/koji/taskinfo?taskID=12217913
Comment 6 Paul Belanger 2015-12-17 12:33:06 EST
Had a chance to run fedora-review on your spec. In general good, but it founds some issues below.  The biggest seems to be related to licensing, a lot of files were missing that. I'm not an expert on LICENCE issue so it would be good to get another person to comment on my review.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "*No copyright* GPL (v3 or later)", "GPL (v3 or later)",
     "Unknown or generated". 117 files have unknown license. Detailed
     output of licensecheck in /tmp/1292244/review-python-
     nsdf/licensecheck.txt
[!]: License file installed when any subpackage combination is installed.
   devel and tools are missing the LICENSE
[ ]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[ ]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[!]: Package consistently uses macros (instead of hard-coded directory
     names).
[ ]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[ ]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[-]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[ ]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[ ]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[ ]: A package which is used by another package via an egg interface should
     provide egg info.
[ ]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[!]: Uses parallel make %{?_smp_mflags} macro.
[ ]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[ ]: Final provides and requires are sane (see attachments).
[ ]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python2-nsdf , python-nsdf-doc
[ ]: Package functions as described.
[ ]: Latest version is packaged.
[ ]: Package does not include license text files separate from upstream.
[ ]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[ ]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[ ]: Package should compile and build into binary rpms on all supported
     architectures.
[ ]: %check is present and all tests pass.
[ ]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python2-nsdf-0.0-1.git2153112.fc24.noarch.rpm
          python-nsdf-doc-0.0-1.git2153112.fc24.noarch.rpm
          python-nsdf-0.0-1.git2153112.fc24.src.rpm
3 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (installed packages)
----------------------------
2 packages and 0 specfiles checked; 0 errors, 0 warnings.



Requires
--------
python-nsdf-doc (rpmlib, GLIBC filtered):

python2-nsdf (rpmlib, GLIBC filtered):
    h5py
    numpy
    python(abi)



Provides
--------
python-nsdf-doc:
    python-nsdf-doc

python2-nsdf:
    python-nsdf
    python-nsdf(x86-64)
    python2-nsdf



Source checksums
----------------
https://github.com/nsdf/nsdf/archive/2153112f441a70ab2cb3723143e4bb44311f4e75.tar.gz#/python-nsdf-2153112f441a70ab2cb3723143e4bb44311f4e75.tar.gz :
  CHECKSUM(SHA256) this package     : 398b2b4d8038f7c18eb4d8a577074dc7c54b280701ad39eebab2d940ec8f2fc6
  CHECKSUM(SHA256) upstream package : 398b2b4d8038f7c18eb4d8a577074dc7c54b280701ad39eebab2d940ec8f2fc6
Comment 7 Zbigniew Jędrzejewski-Szmek 2015-12-17 22:23:37 EST
(In reply to Paul Belanger from comment #6)
> Had a chance to run fedora-review on your spec.
Thanks!

> In general good, but it
> founds some issues below.  The biggest seems to be related to licensing, a
> lot of files were missing that. I'm not an expert on LICENCE issue so it
> would be good to get another person to comment on my review.
> 
> Package Review
> ==============
> 
> Legend:
> [x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
> [ ] = Manual review needed
Usually you'd fill all boxes in (one way or another), and then remove this line.

> [!]: License field in the package spec file matches the actual license.
>      Note: Checking patched sources after %prep for licenses. Licenses
>      found: "*No copyright* GPL (v3 or later)", "GPL (v3 or later)",
>      "Unknown or generated". 117 files have unknown license. Detailed
>      output of licensecheck in /tmp/1292244/review-python-
>      nsdf/licensecheck.txt
The license is specified as GPLv3+ in the spec file, and those
headers that specify the license match that.
It is quite normal for many individual files not to have licensing
information or copyright statements, and this is not treated as an error.
The main guidelines [1,2] don't address this case specifically, but in the FAQ
there are similar considerations (see point 3 in
https://fedoraproject.org/wiki/Licensing:FAQ?rd=Licensing/FAQ#How_do_I_figure_out_what_version_of_the_GPL.2FLGPL_my_package_is_under.3F)
It seems common sense to assume that if the README or setup.py or some headers specify
a license, and there is no disagreement between them, that this is the license.

[1] https://fedoraproject.org/wiki/Licensing:Main
[2] https://fedoraproject.org/wiki/Packaging:LicensingGuidelines

> [!]: License file installed when any subpackage combination is installed.
>    devel and tools are missing the LICENSE
Different package? This one only has python2-nsdf and python-nsdf-doc subpackages,
and both have the README, although they don't have a LICENSE file, because
on is missing from the upstream repo and tarball.

You could (and should) say instead, that I'm supposed to contact upstream about
adding a license file. Indeed, I haven't done this.

> [ ]: Package contains no bundled libraries without FPC exception.
> [x]: Changelog in prescribed format.
> [ ]: Sources contain only permissible code or content.
> [-]: Package contains desktop file if it is a GUI application.
> [x]: Development files must be in a -devel package
> [x]: Package uses nothing in %doc for runtime.
> [!]: Package consistently uses macros (instead of hard-coded directory
>      names).
Can you be more specific here?

> [ ]: Package is named according to the Package Naming Guidelines.
> [x]: Package does not generate any conflict.
> [ ]: Package obeys FHS, except libexecdir and /usr/target.
> [-]: If the package is a rename of another package, proper Obsoletes and
>      Provides are present.
> [-]: Requires correct, justified where necessary.
> [x]: Spec file is legible and written in American English.
> [-]: Package contains systemd file(s) if in need.
> [ ]: Package is not known to require an ExcludeArch tag.
> [x]: Large documentation must go in a -doc subpackage. Large could be size
>      (~1MB) or number of files.
>      Note: Documentation size is 10240 bytes in 1 files.
> [ ]: Package complies to the Packaging Guidelines
> [x]: Package successfully compiles and builds into binary rpms on at least
>      one supported primary architecture.
> [x]: Package installs properly.
> [x]: Rpmlint is run on all rpms the build produces.
>      Note: No rpmlint messages.
> [x]: Package requires other packages for directories it uses.
> [x]: Package must own all directories that it creates.
> [x]: Package does not own files or directories owned by other packages.
> [x]: All build dependencies are listed in BuildRequires, except for any
>      that are listed in the exceptions section of Packaging Guidelines.
> [x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
> [x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
>      beginning of %install.
> [x]: Macros in Summary, %description expandable at SRPM build time.
> [x]: Dist tag is present.
> [x]: Package does not contain duplicates in %files.
> [x]: Permissions on files are set properly.
> [x]: Package use %makeinstall only when make install DESTDIR=... doesn't
>      work.
> [x]: Package is named using only allowed ASCII characters.
> [x]: Package does not use a name that already exists.
> [x]: Package is not relocatable.
> [x]: Sources used to build the package match the upstream source, as
>      provided in the spec URL.
> [x]: Spec file name must match the spec package %{name}, in the format
>      %{name}.spec.
> [x]: File names are valid UTF-8.
> [x]: Packages must not store files under /srv, /opt or /usr/local
> 
> Python:
> [x]: Python eggs must not download any dependencies during the build
>      process.
> [ ]: A package which is used by another package via an egg interface should
>      provide egg info.
> [ ]: Package meets the Packaging Guidelines::Python
> [x]: Package contains BR: python2-devel or python3-devel
> [x]: Binary eggs must be removed in %prep
> 
> ===== SHOULD items =====
> 
> Generic:
> [!]: Uses parallel make %{?_smp_mflags} macro.
It uses the standard %py2_build macro. If this is not paralellized, and
could be, than this might be a bug in python2-devel.

In this case "build" is really copying a few files to build/lib, so it doesn't
really matter either way.

> [ ]: If the source package does not include license text(s) as a separate
>      file from upstream, the packager SHOULD query upstream to include it.
> [ ]: Final provides and requires are sane (see attachments).
> [ ]: Fully versioned dependency in subpackages if applicable.
>      Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
>      python2-nsdf , python-nsdf-doc
> [ ]: Package functions as described.
> [ ]: Latest version is packaged.
> [ ]: Package does not include license text files separate from upstream.
> [ ]: Patches link to upstream bugs/comments/lists or are otherwise
>      justified.
> [ ]: Description and summary sections in the package spec file contains
>      translations for supported Non-English languages, if available.
> [ ]: Package should compile and build into binary rpms on all supported
>      architectures.
> [ ]: %check is present and all tests pass.
> [ ]: Packages should try to preserve timestamps of original installed
>      files.
> [x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
> [x]: Sources can be downloaded from URI in Source: tag
> [x]: Reviewer should test that the package builds in mock.
> [x]: Buildroot is not present
> [x]: Package has no %clean section with rm -rf %{buildroot} (or
>      $RPM_BUILD_ROOT)
> [x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
> [x]: SourceX is a working URL.
> [x]: Spec use %global instead of %define unless justified.
> 
> ===== EXTRA items =====
> 
> Generic:
> [x]: Rpmlint is run on all installed packages.
>      Note: No rpmlint messages.
> [x]: Spec file according to URL is the same as in SRPM.

What about all the open boxes [ ]?
Comment 8 Paul Belanger 2015-12-22 10:41:46 EST
(In reply to Zbigniew Jędrzejewski-Szmek from comment #7)
> (In reply to Paul Belanger from comment #6)
> > Had a chance to run fedora-review on your spec.
> Thanks!
> 
> > In general good, but it
> > founds some issues below.  The biggest seems to be related to licensing, a
> > lot of files were missing that. I'm not an expert on LICENCE issue so it
> > would be good to get another person to comment on my review.
> > 
> > Package Review
> > ==============
> > 
> > Legend:
> > [x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
> > [ ] = Manual review needed
> Usually you'd fill all boxes in (one way or another), and then remove this
> line.
> 
> > [!]: License field in the package spec file matches the actual license.
> >      Note: Checking patched sources after %prep for licenses. Licenses
> >      found: "*No copyright* GPL (v3 or later)", "GPL (v3 or later)",
> >      "Unknown or generated". 117 files have unknown license. Detailed
> >      output of licensecheck in /tmp/1292244/review-python-
> >      nsdf/licensecheck.txt
> The license is specified as GPLv3+ in the spec file, and those
> headers that specify the license match that.
> It is quite normal for many individual files not to have licensing
> information or copyright statements, and this is not treated as an error.
> The main guidelines [1,2] don't address this case specifically, but in the
> FAQ
> there are similar considerations (see point 3 in
> https://fedoraproject.org/wiki/Licensing:FAQ?rd=Licensing/
> FAQ#How_do_I_figure_out_what_version_of_the_GPL.2FLGPL_my_package_is_under.
> 3F)
> It seems common sense to assume that if the README or setup.py or some
> headers specify
> a license, and there is no disagreement between them, that this is the
> license.
> 
> [1] https://fedoraproject.org/wiki/Licensing:Main
> [2] https://fedoraproject.org/wiki/Packaging:LicensingGuidelines
> 
> > [!]: License file installed when any subpackage combination is installed.
> >    devel and tools are missing the LICENSE
> Different package? This one only has python2-nsdf and python-nsdf-doc
> subpackages,
> and both have the README, although they don't have a LICENSE file, because
> on is missing from the upstream repo and tarball.
> 
> You could (and should) say instead, that I'm supposed to contact upstream
> about
> adding a license file. Indeed, I haven't done this.
> 
Right, I had noticed the LICENSE was not installed in the files sections.  I should have been more detailed about notifying you about that.

> > [ ]: Package contains no bundled libraries without FPC exception.
> > [x]: Changelog in prescribed format.
> > [ ]: Sources contain only permissible code or content.
> > [-]: Package contains desktop file if it is a GUI application.
> > [x]: Development files must be in a -devel package
> > [x]: Package uses nothing in %doc for runtime.
> > [!]: Package consistently uses macros (instead of hard-coded directory
> >      names).
> Can you be more specific here?
> 
Doh, I missed my comment at the top.  For this, I was looking at other reviews an noticed the nsdf name seemed copied over the entire spec file, vs setting up a macro for %{pypi_name} or %{srcname}.

> > [ ]: Package is named according to the Package Naming Guidelines.
> > [x]: Package does not generate any conflict.
> > [ ]: Package obeys FHS, except libexecdir and /usr/target.
> > [-]: If the package is a rename of another package, proper Obsoletes and
> >      Provides are present.
> > [-]: Requires correct, justified where necessary.
> > [x]: Spec file is legible and written in American English.
> > [-]: Package contains systemd file(s) if in need.
> > [ ]: Package is not known to require an ExcludeArch tag.
> > [x]: Large documentation must go in a -doc subpackage. Large could be size
> >      (~1MB) or number of files.
> >      Note: Documentation size is 10240 bytes in 1 files.
> > [ ]: Package complies to the Packaging Guidelines
> > [x]: Package successfully compiles and builds into binary rpms on at least
> >      one supported primary architecture.
> > [x]: Package installs properly.
> > [x]: Rpmlint is run on all rpms the build produces.
> >      Note: No rpmlint messages.
> > [x]: Package requires other packages for directories it uses.
> > [x]: Package must own all directories that it creates.
> > [x]: Package does not own files or directories owned by other packages.
> > [x]: All build dependencies are listed in BuildRequires, except for any
> >      that are listed in the exceptions section of Packaging Guidelines.
> > [x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
> > [x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
> >      beginning of %install.
> > [x]: Macros in Summary, %description expandable at SRPM build time.
> > [x]: Dist tag is present.
> > [x]: Package does not contain duplicates in %files.
> > [x]: Permissions on files are set properly.
> > [x]: Package use %makeinstall only when make install DESTDIR=... doesn't
> >      work.
> > [x]: Package is named using only allowed ASCII characters.
> > [x]: Package does not use a name that already exists.
> > [x]: Package is not relocatable.
> > [x]: Sources used to build the package match the upstream source, as
> >      provided in the spec URL.
> > [x]: Spec file name must match the spec package %{name}, in the format
> >      %{name}.spec.
> > [x]: File names are valid UTF-8.
> > [x]: Packages must not store files under /srv, /opt or /usr/local
> > 
> > Python:
> > [x]: Python eggs must not download any dependencies during the build
> >      process.
> > [ ]: A package which is used by another package via an egg interface should
> >      provide egg info.
> > [ ]: Package meets the Packaging Guidelines::Python
> > [x]: Package contains BR: python2-devel or python3-devel
> > [x]: Binary eggs must be removed in %prep
> > 
> > ===== SHOULD items =====
> > 
> > Generic:
> > [!]: Uses parallel make %{?_smp_mflags} macro.
> It uses the standard %py2_build macro. If this is not paralellized, and
> could be, than this might be a bug in python2-devel.
> 
> In this case "build" is really copying a few files to build/lib, so it
> doesn't
> really matter either way.
> 
This left by fedora-review.  Since this was one of the first reviews I did, I really depended on the automated tool to catch a lot of stuff.

> > [ ]: If the source package does not include license text(s) as a separate
> >      file from upstream, the packager SHOULD query upstream to include it.
> > [ ]: Final provides and requires are sane (see attachments).
> > [ ]: Fully versioned dependency in subpackages if applicable.
> >      Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
> >      python2-nsdf , python-nsdf-doc
> > [ ]: Package functions as described.
> > [ ]: Latest version is packaged.
> > [ ]: Package does not include license text files separate from upstream.
> > [ ]: Patches link to upstream bugs/comments/lists or are otherwise
> >      justified.
> > [ ]: Description and summary sections in the package spec file contains
> >      translations for supported Non-English languages, if available.
> > [ ]: Package should compile and build into binary rpms on all supported
> >      architectures.
> > [ ]: %check is present and all tests pass.
> > [ ]: Packages should try to preserve timestamps of original installed
> >      files.
> > [x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
> > [x]: Sources can be downloaded from URI in Source: tag
> > [x]: Reviewer should test that the package builds in mock.
> > [x]: Buildroot is not present
> > [x]: Package has no %clean section with rm -rf %{buildroot} (or
> >      $RPM_BUILD_ROOT)
> > [x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
> > [x]: SourceX is a working URL.
> > [x]: Spec use %global instead of %define unless justified.
> > 
> > ===== EXTRA items =====
> > 
> > Generic:
> > [x]: Rpmlint is run on all installed packages.
> >      Note: No rpmlint messages.
> > [x]: Spec file according to URL is the same as in SRPM.
> 
> What about all the open boxes [ ]?

Thanks for the feedback, I admit I should have likely removed the open boxes lines. I wasn't comfortable filling some of them in.

Moving forward, I'll do my best to leave more detail, then less for reviews.
Comment 9 Zbigniew Jędrzejewski-Szmek 2016-01-07 17:53:36 EST
(In reply to Paul Belanger from comment #8)
> (In reply to Zbigniew Jędrzejewski-Szmek from comment #7)
> > (In reply to Paul Belanger from comment #6)
> > > [!]: License file installed when any subpackage combination is installed.
> > >    devel and tools are missing the LICENSE
> > Different package? This one only has python2-nsdf and python-nsdf-doc
> > subpackages,
> > and both have the README, although they don't have a LICENSE file, because
> > on is missing from the upstream repo and tarball.
> > 
> > You could (and should) say instead, that I'm supposed to contact upstream
> > about
> > adding a license file. Indeed, I haven't done this.
> > 
> Right, I had noticed the LICENSE was not installed in the files sections.  I
> should have been more detailed about notifying you about that.

I contacted upstream about adding a license:
https://github.com/nsdf/nsdf/pull/41.

> > > [ ]: Package contains no bundled libraries without FPC exception.
> > > [x]: Changelog in prescribed format.
> > > [ ]: Sources contain only permissible code or content.
> > > [-]: Package contains desktop file if it is a GUI application.
> > > [x]: Development files must be in a -devel package
> > > [x]: Package uses nothing in %doc for runtime.
> > > [!]: Package consistently uses macros (instead of hard-coded directory
> > >      names).
> > Can you be more specific here?
> > 
> Doh, I missed my comment at the top.  For this, I was looking at other
> reviews an noticed the nsdf name seemed copied over the entire spec file, vs
> setting up a macro for %{pypi_name} or %{srcname}.

Note that the guideline is about "hard-coded *directory* names". Directory
names indeed can change and vary between architectures, and are long, so using
macros makes sense. Similarly for version and other things which are updated
regularly. But the package name is unlikely to *ever* change, so using a macro
doesn't buy anything. In fact I find %{pypi_name} or %{srcname} much less
readable than the package name.

(On a similar note: people sometime use %{__make} instead of just make, and
simalar macros for other basic commands. I think it's pointless, because
make's name is never going to change, and/or if somebody can insert a different
make in $PATH, they can just as well insert any other command called from
the Makefile, so there's no reason to single out make just because it is called
directly. So again, using macros for *files* is again a waste of keystrokes
(as opposed to directory names).)
 
> > What about all the open boxes [ ]?
> 
> Thanks for the feedback, I admit I should have likely removed the open boxes
> lines. I wasn't comfortable filling some of them in.
> 
> Moving forward, I'll do my best to leave more detail, then less for reviews.

Cool.
Comment 10 William Moreno 2016-01-08 17:29:39 EST
Did you check your koji build?

Your are using many python3 conditionals but you do not define what does this conditional means so you are only building a python2 subpackage.

You can get the license file from upstream:
https://github.com/nsdf/nsdf/blob/master/LICENSE

Open a issue upstream requesting to include the LICENSE text in the tarball, you can patch the license file so GLPv3 requires to provide a copy of the license text.
Comment 11 William Moreno 2016-01-08 17:36:36 EST
Package Review
==============
[!]: License file installed when any subpackage combination is installed.

This package looks good but I can not aprove it if you dont remove the conditionals and build the python3 subpackage.A

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[-]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: License field in the package spec file matches the actual license.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. 
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.

Rpmlint
-------
Checking: python2-nsdf-0.0-1.git2153112.fc24.noarch.rpm
          python-nsdf-doc-0.0-1.git2153112.fc24.noarch.rpm
          python-nsdf-0.0-1.git2153112.fc24.src.rpm
3 packages and 0 specfiles checked; 0 errors, 0 warnings.

Rpmlint (installed packages)
----------------------------
2 packages and 0 specfiles checked; 0 errors, 0 warnings.

Requires
--------
python-nsdf-doc (rpmlib, GLIBC filtered):

python2-nsdf (rpmlib, GLIBC filtered):
    h5py
    numpy
    python(abi)

Provides
--------
python-nsdf-doc:
    python-nsdf-doc

python2-nsdf:
    python-nsdf
    python-nsdf(x86-64)
    python2-nsdf

Source checksums
----------------
https://github.com/nsdf/nsdf/archive/2153112f441a70ab2cb3723143e4bb44311f4e75.tar.gz#/python-nsdf-2153112f441a70ab2cb3723143e4bb44311f4e75.tar.gz :
  CHECKSUM(SHA256) this package     : 398b2b4d8038f7c18eb4d8a577074dc7c54b280701ad39eebab2d940ec8f2fc6
  CHECKSUM(SHA256) upstream package : 398b2b4d8038f7c18eb4d8a577074dc7c54b280701ad39eebab2d940ec8f2fc6
Comment 12 Zbigniew Jędrzejewski-Szmek 2016-01-08 18:02:34 EST
(In reply to William Moreno from comment #10)
> Did you check your koji build?
> 
> Your are using many python3 conditionals but you do not define what does
> this conditional means so you are only building a python2 subpackage.
Yes, this is on purpose. Upstream only supports python2, package needs porting to python3. There's *was* a macro at the top of the spec file '%global with_python3 0', but without any comment. I added the comment now, and opened an issue upstream: https://github.com/nsdf/nsdf/issues/42.

> You can get the license file from upstream:
> https://github.com/nsdf/nsdf/blob/master/LICENSE
Yes, they merged my pull request yesterday ;)

> Open a issue upstream requesting to include the LICENSE text in the tarball,
> you can patch the license file so GLPv3 requires to provide a copy of the
> license text.
Already done and merged:
https://github.com/nsdf/nsdf/commit/466c2a3f3ada

(In reply to William Moreno from comment #11)
> Package Review
> ==============
> [!]: License file installed when any subpackage combination is installed.
Should be fixed now.

Thanks for the review!

Spec URL: https://in.waw.pl/~zbyszek/fedora/python-nsdf.spec
SRPM URL: https://in.waw.pl/~zbyszek/fedora/python-nsdf-0.0-2.git9621ced.fc24.src.rpm

* Fri Jan  8 2016 Zbigniew Jędrzejewski-Szmek <zbyszek@in.waw.pl> - 0.0-2.git9621ced
- Update to latest git snapshot
- Add LICENSE to %%files
Comment 13 William Moreno 2016-01-08 18:53:42 EST
Package Aproved
===============
Comment 14 Zbigniew Jędrzejewski-Szmek 2016-01-08 19:28:33 EST
Thank you.
Comment 15 Gwyn Ciesla 2016-01-08 20:08:36 EST
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/python-nsdf
Comment 16 Fedora Update System 2016-01-08 21:38:40 EST
python-nsdf-0.0-2.git9621ced.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2016-69d7ede8aa
Comment 17 Fedora Update System 2016-01-09 13:21:02 EST
python-nsdf-0.0-2.git9621ced.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-69d7ede8aa
Comment 18 Fedora Update System 2016-01-09 13:21:53 EST
python-nsdf-0.0-2.git9621ced.fc22 has been pushed to the Fedora 22 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-610eef149f
Comment 19 Fedora Update System 2016-01-17 12:51:16 EST
python-nsdf-0.0-2.git9621ced.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.
Comment 20 Fedora Update System 2016-01-17 13:50:57 EST
python-nsdf-0.0-2.git9621ced.fc22 has been pushed to the Fedora 22 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.